#ifndef __AVMEMODULE_H
#define __AVMEMODULE_H
                                      
#include <config.h>
#include <string>
using namespace std;

#include <CVMEInterface.h>
// # include <SBSBit3API.h>

// # i nclude "defs.h"

class AVmeModule      
{ 
private:
	string	m_sName;
	int		m_nCrate;
	int		m_nSlot;
	long		m_lBase;
	int	*	m_pDevice;
  
public:
  // Constructors, destructors and other cannonical operations: 
  	AVmeModule ( string name, unsigned int slot, long base);
  	AVmeModule ( string name, unsigned int slot);
  	AVmeModule ( string name, unsigned int crate, unsigned int slot, long base);
  	AVmeModule ( string name, unsigned int crate, unsigned int slot);
	AVmeModule(const AVmeModule& rhs); //!< Copy constructor.
	~AVmeModule ( );	//!< Destructor.
  
	AVmeModule& operator= (const AVmeModule& rhs); //!< Assignment
	int           operator==(const AVmeModule& rhs) const; //!< Comparison for equality.
	int         operator!=(const AVmeModule& rhs) const {
	return !(operator==(rhs));
  }
  
  // Selectors for class attributes:
public:
  
  string getName() const {
    return m_sName;
  }
  
  int getSlot() const {
    return m_nSlot;
  }
  
  long getBase() const {
  	return m_lBase;
  }
  
  // Mutators:
protected:  
  
  // Class operations:
public:
  
  // Additional useful functions:
  
  static bool	ValidSlot(unsigned int slot);
  long*			Map(long offset, long length);
  void				SetBlockMode(bool b);
  void				ReadBlockMode(long *data, long length);
};


#endif
