//  ReadoutMain.cpp:
//     This file is the version 0.1 readout control main program.
//     we must:
//       1. Open the VME device driver in A24/D16 mode.
//       2. Ensure that the VME crate is online.
//       3. Map to the CAMAC crate and save the base address as a global
//          variable named CAMBAS.
//       4. Instantiate a ReadoutStateMachine object.
//       5. Run it.
//       6. Exit when the state machine exits.
//
// Author:
//    Ron Fox
//    NSCL
//    Michigan State University
//    East Lansing, MI 48824-1321
//    mailto:fox@nscl.msu.edu
//
//////////////////////////////////////////////////////////////////////////


static const char* Copyright =
"(c) Copyright NSCL All rights reserved 1999 ReadoutMain.cpp\n";

//
// Include files:
//
#include <errno.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <unistd.h>
#include "TCLThread.h"
//
//   Global Variables:
//

extern int UsingVME;
void* pCamac;

//UINT32  CAMBAS = 0;			// Base address of camac space.
//int     nCamacFd;

// External Prototypes
extern void InitChip(int MBNO);



int
main(int argc, char**argv)
{

  TCLTK  interp;
  char* TclArgs[]={"CHIP", "./silstrip.tcl"};
  interp.Start(2,TclArgs);

  while(1)
    sleep(100);
}
